freeslot("sfx_earjmp", "S_EAR_ROLLSTND")
states[S_EAR_ROLLSTND] = {SPR_PLAY, SPR2_LAND, -1, nil, 0, 0, S_EAR_ROLLSTND}
sfxinfo[sfx_earjmp].caption = "Double Jump"

//particle junk
local jumpdust = function(inflictor, ns, item)
	local i = 0
	while i < 15
		local fa = (i*(ANGLE_180/8))
		local mo = P_SpawnMobj(inflictor.x, inflictor.y, inflictor.z, item)
		mo.scale = inflictor.scale
		if mo and mo.valid
			mo.momy = FixedMul(cos(fa), ns)
			mo.momx = FixedMul(sin(fa), ns)
		end
		i = $+1
	end
end

//basically everything
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
	and (player.mo.skin == "earlessreredo")
	and player.playerstate == PST_LIVE 	
	
		//jumping at a standstill and landing kept you in jump form, lets replicate that :)
		if (player.mo.eflags & MFE_JUSTHITFLOOR)
		and player.speed == 0 and player.cmd.forwardmove == 0 and player.cmd.sidemove == 0
			player.mo.state = S_EAR_ROLLSTND
		end
				
		if player.speed != 0 and player.mo.state == S_EAR_ROLLSTND
			player.mo.state = S_PLAY_WALK
		end
		
		//you can actually stick to ceilings by holding jump, might make some stuff fun
		if (abs((player.mo.z + player.mo.height) - P_CeilingzAtPos(player.mo.x, player.mo.y, player.mo.z, player.mo.height))) < FixedMul(player.mo.scale, 18*FRACUNIT)
		and (player.cmd.buttons & BT_JUMP) 
		and (player.pflags & PF_JUMPED)
		and not (player.mo.eflags & MFE_SPRUNG)
		and not (player.mo.eflags & MFE_VERTICALFLIP)
		and not (player.pflags & PF_SHIELDABILITY)
		or (player.mo.eflags & MFE_VERTICALFLIP)
		and (player.cmd.buttons & BT_JUMP) 
		and (player.pflags & PF_JUMPED)
		and not (player.mo.eflags & MFE_SPRUNG)
		and not (player.pflags & PF_SHIELDABILITY)
		and (abs(player.mo.z - P_FloorzAtPos(player.mo.x, player.mo.y, player.mo.z, player.mo.height)) < FixedMul(player.mo.scale, 18*FRACUNIT))
			if player.earjumpnum == 2
				player.earjumpnum = 3
			end
			player.mo.momz = 0
			if player.mo.state != S_PLAY_ROLL
				player.mo.state = S_PLAY_ROLL
			end
		end
		//measure jumps
		if player.earjumpnum == nil 
			player.earjumpnum = 0 
			player.justjumped = 0
			player.jumpcheck = 0
			player.earthokspeed = 0
		end
		if player.squashtime == nil
			player.squashtime = 0
		end
		if P_IsObjectOnGround(player.mo) 
		and player.jumpcheck == 0 
			player.earjumpnum = 0 
		end
		
		//to prevent the thing
		if player.usedown == nil 
		or not (player.cmd.buttons & BT_JUMP) 
			player.usedown = 0
			player.justjumped = 0 
		end
		if P_IsObjectOnGround(player.mo) 
		and (player.cmd.buttons & BT_JUMP) 
			player.usedown = 1 
		end
		
		//---------------------------------------------------------------------
		
		if player.pflags & PF_JUMPED 
		and player.usedown == 0 
		and not (player.pflags & PF_THOKKED) 
		and player.cmd.buttons & BT_JUMP 
		and player.jumpcheck == 0 
		and not (player.exiting) 
		and player.mo.health 
		and not (P_PlayerInPain(player)) 
			player.jumpcheck = 1 
		end
			
		//jumping time, lets make sure a bunch of stuff aint happenin when we do it first		
		if not (player.pflags & PF_STARTDASH) 
		and not (tracer and tracer.type == MT_TUBEWAYPOINT) 
		and player.jumpcheck == 1 
		and player.mo.health 
		and not (P_PlayerInPain(player)) 
		or player.jumpcheck == 1
		and not P_IsObjectOnGround(player.mo)
		and not (player.pflags & PF_THOKKED)
			if player.mo.state == S_PLAY_DASH return end
			//first jump
			if player.earjumpnum == 0 
				if player.squashtime == 0
					player.squashtime = 1
				end
				player.justjumped = 1 
				player.earjumpnum = 1 //you just jumped weenie congrats
				player.pflags = $1|PF_JUMPED 
				if player.isxmomentum //fuck you, lets boost the jump some more >:)
					P_SetObjectMomZ(player.mo, (player.speed/20) + (player.mo.momz))
				end
			end
			
			if player.earjumpnum == 1 //the thok
			and player.justjumped == 0 
			and not (P_PlayerInPain(player)) 
			and not (player.mo.eflags & MFE_JUSTHITFLOOR)
			and not P_IsObjectOnGround(player.mo)
				player.earthokspeed = player.speed + 12*player.mo.scale
				if player.earthokspeed > 60*player.mo.scale and not player.isxmomentum
					player.earthokspeed = 60*player.mo.scale
				end
				
				if player.isxmomentum
					//ripped right from xmom
					if player.earthokspeed > 70*FRACUNIT
						local thokko = P_SpawnMobjFromMobj(player.mo, 0, 0, player.mo.scale * 20, MT_THOKKO)
						thokko.angle = player.mo.angle + ANGLE_90
						thokko.fuse = 7
						thokko.scale = 2*FRACUNIT/3
						thokko.destscale = 10*FRACUNIT
						thokko.colorized = true
						thokko.color = player.mo.color
						S_StartSound(player.mo, sfx_kc5b)
						player.thokeffects = true
						local cometthok = P_SpawnMobjFromMobj(player.mo, 0, 0, player.mo.scale * 20, MT_STARTHOK)
						cometthok.angle = player.mo.angle
						cometthok.fuse = 27
						cometthok.scale = 2*FRACUNIT
						cometthok.destscale = 1*FRACUNIT/2
						cometthok.color = player.mo.color
						cometthok.source = player.mo
					end
					player.earthokspeed = player.earthokspeed - 6*FRACUNIT //woah there buddy slow it down a bit
				end
				
				P_InstaThrust(player.mo, player.mo.angle, player.earthokspeed)
				
				player.mo.state = S_PLAY_ROLL
				player.justjumped = 1 
				player.earjumpnum = 2
				S_StartSound(player.mo, sfx_zoom)
				player.pflags = $1|PF_THOKKED
			end
			player.jumpcheck = 0
			player.usedown = 1 	
		end
		
		
		//hey lets do a cool trail for the thok
		if player.earjumpnum == 2
		and player.mo.state == S_PLAY_ROLL		
			for i = 0, 9
				local percent = FRACUNIT * (i * 10) / 100
				local trail = P_SpawnGhostMobj(player.mo)
				P_TeleportMove(trail, player.mo.x, player.mo.y, player.mo.z - 7 * FRACUNIT)
				trail.fuse = 13
				trail.state = S_THOK
				trail.scalespeed = FRACUNIT/12
				trail.scale = (FRACUNIT * 5/6) - (i * FRACUNIT/120)
				trail.destscale = 0
				trail.frame = TR_TRANS70|A
			end
		end
		
		//s t r e t c h
		if player.squashtime >= 1 and player.squashtime <= 10
			player.squashtime = $+1
			if player.squashtime > 5
				player.mo.spritexscale = $ + FRACUNIT/35
				player.mo.spriteyscale = $ - FRACUNIT/35
			else
				player.mo.spritexscale = $ - FRACUNIT/35
				player.mo.spriteyscale = $ + FRACUNIT/35
			end
			if player.squashtime == 10
				player.mo.spritexscale = FRACUNIT
				player.mo.spriteyscale = FRACUNIT
				player.squashtime = 0
			end
		end
		if player.mo.state != S_PLAY_JUMP
		and (player.mo.spritexscale != FRACUNIT)
			player.mo.spritexscale = FRACUNIT
			player.mo.spriteyscale = FRACUNIT
		end
		
		if P_IsObjectOnGround(player.mo)
		or (player.mo.eflags & MFE_JUSTHITFLOOR)
			player.activatefunny = false
			player.earjumpnum = 0
			player.clungerear = 0
			player.walltouch = 0
		end			
		
		//reset jumps if carried
		if player.powers[pw_carry]
		or player.powers[pw_carry] == CR_MACESPIN
			player.jumpcheck = 0 
			player.earjumpnum = 0
		end
		
		//self explanatory
		if not (player.pflags & PF_JUMPED) 
		or (player.mo.eflags & MFE_JUSTHITFLOOR)
			player.jumpcheck = 0 
			player.earjumpnum = 0
		end
		
		if (player.pflags & PF_SPINNING)
		and player.mo.state != S_PLAY_ROLL
			player.mo.state = S_PLAY_ROLL
		end
		
		//stop freaking out when you jump the second you hit the ground
		if (player.mo.eflags & MFE_JUSTHITFLOOR)
		and player.cmd.buttons & BT_JUMP
			player.earjumpnum = 1
		end
		
		//you too
		if ((player.mo.eflags & MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo))
		and player.pflags & PF_JUMPED
			player.earjumpnum = 1
		end
		
		//hey, wanna bring back an obscure bug?
		if player.coyotehover == nil
		or (player.pflags & PF_JUMPED)
		or (player.mo.eflags & MFE_JUSTHITFLOOR)
			player.coyotehover = false
			player.coyothovr = 31
		end
		
		if player.pflags & PF_STARTDASH
			player.coyotehover = true
		end
		
		if player.coyotehover == true
		and player.pflags & PF_SPINNING
		and player.coyothovr > 0
		and not (player.pflags & PF_STARTDASH)
		and not P_IsObjectOnGround(player.mo)
			player.mo.momz = $ - P_GetMobjGravity(player.mo)*1/2
			player.coyothovr = $-1
			if leveltime % 2 == 0
				P_SpawnMobj(player.mo.x + (P_RandomRange(-32,32)*player.mo.scale),player.mo.y + (P_RandomRange(-32,32)*player.mo.scale),player.mo.z -4*player.mo.scale,MT_BOXSPARKLE)
				P_SpawnMobj(player.mo.x + (P_RandomRange(-32,32)*player.mo.scale),player.mo.y + (P_RandomRange(-32,32)*player.mo.scale),player.mo.z -4*player.mo.scale,MT_BOXSPARKLE)
				P_SpawnMobj(player.mo.x + (P_RandomRange(-32,32)*player.mo.scale),player.mo.y + (P_RandomRange(-32,32)*player.mo.scale),player.mo.z -4*player.mo.scale,MT_BOXSPARKLE)
			end
			if player.coyothovr == 30
				S_StartSound(player.mo, sfx_s3kb8)
			end
		end
		
		
		//wait, you walked off a ledge? you mean JUMPED off a ledge.
		if not (P_IsObjectOnGround(player.mo))
		and (player.mo.state == S_PLAY_RUN or player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_SKID)
		and player.mo.state != S_PLAY_ROLL
		and not player.powers[pw_carry]
		and player.earjumpnum == 0
			player.earjumpnum = 3 //prevent thokking, weird with the flow
			player.pflags = $1|PF_JUMPED
			player.mo.state = S_PLAY_JUMP
		end		
	end
	if player.mo and player.mo.valid
	and not (player.mo.skin == "earlessreredo")
	and player.mo.state == S_EAR_ROLLSTND
		player.mo.state = S_PLAY_STND
	end
end)


// Poyo Bitch
if not(kirbyabilitytable)
	rawset(_G, "kirbyabilitytable", {})
end
kirbyabilitytable["earlessreredo"] = 9

local BattleFuncSet = false

// Battle
addHook("ThinkFrame",function()
	if (BattleFuncSet) or not(CBW_Battle and CBW_Battle.SkinVars) then return end
	BattleFuncSet = true

	CBW_Battle.SkinVars["earlessreredo"] = {
 		weight = 90,
 		shields = 1,
		special = CBW_Battle.Action.SuperSpinJump,
 		guard_enabled = true,
 		guard_frame = 6,
 		func_guard_trigger = CBW_Battle.GuardFunc.Parry,
 		func_priority = CBW_Battle.Priority_FullCommon,
 		func_priority_ext = PriorityFunction
	}
end)

//hugs :)
addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo and player.mo.skin == "earlessreredo") then
			if (player.hugged) then
				player.mo.sprite2 = SPR2_HUG_
			end
		end
	end
end)

freeslot("SKINCOLOR_SUPER_EARLESS_1", "SKINCOLOR_SUPER_EARLESS_2", "SKINCOLOR_SUPER_EARLESS_3", "SKINCOLOR_SUPER_EARLESS_4", "SKINCOLOR_SUPER_EARLESS_5")

skincolors[SKINCOLOR_SUPER_EARLESS_1] = {
	name = "Super Earless 1",
	ramp = {216,49,50,51,52,53,53,55,56,57,58,59,60,61,63,70},
	invcolor = SKINCOLOR_CERULEAN,
	invshade = 8,
	chatcolor = V_YELLOWMAP,
	accessible = false
}

skincolors[SKINCOLOR_SUPER_EARLESS_2] = {
	name = "Super Earless 2",
	ramp = {0,208,48,49,50,51,51,52,52,53,56,57,57,58,59,59},
	invcolor = SKINCOLOR_CERULEAN,
	invshade = 8,
	chatcolor = V_YELLOWMAP,
	accessible = false
}

skincolors[SKINCOLOR_SUPER_EARLESS_3] = {
	name = "Super Earless 3",
	ramp = {81,81,82,84,84,64,64,64,65,65,65,66,66,67,67,68},
	invcolor = SKINCOLOR_CERULEAN,
	invshade = 8,
	chatcolor = V_YELLOWMAP,
	accessible = false
}

skincolors[SKINCOLOR_SUPER_EARLESS_4] = {
	name = "Super Earless 4",
	ramp = {0,80,80,81,82,83,72,72,73,73,74,75,75,76,77,78},
	invcolor = SKINCOLOR_CERULEAN,
	invshade = 8,
	chatcolor = V_YELLOWMAP,
	accessible = false
}

skincolors[SKINCOLOR_SUPER_EARLESS_5] = {
	name = "Super Earless 5",
	ramp = {0,0,0,0,0,0,0,0,80,80,80,81,82,83,72,72},
	invcolor = SKINCOLOR_CERULEAN,
	invshade = 8,
	chatcolor = V_YELLOWMAP,
	accessible = false
}